--- old/usr/src/uts/common/fs/nfs/nfs4_vnops.c	Fri Jan 18 13:59:18 2013
+++ new/usr/src/uts/common/fs/nfs/nfs4_vnops.c	Fri Jan 18 13:59:18 2013
@@ -31,6 +31,10 @@
  *	All Rights Reserved
  */
 
+/*
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
+ */
+
 #include <sys/param.h>
 #include <sys/types.h>
 #include <sys/systm.h>
@@ -6653,9 +6657,6 @@
 	} else {
 		vnode_t *tvp;
 		rnode4_t *trp;
-		/*
-		 * existing file got truncated, notify.
-		 */
 		tvp = vp;
 		if (vp->v_type == VREG) {
 			trp = VTOR4(vp);
@@ -6662,7 +6663,14 @@
 			if (IS_SHADOW(vp, trp))
 				tvp = RTOV4(trp);
 		}
-		vnevent_create(tvp, ct);
+
+		if (must_trunc) {
+			/*
+			 * existing file got truncated, notify.
+			 */
+			vnevent_create(tvp, ct);
+		}
+
 		*vpp = vp;
 	}
 	return (error);
